<?php

namespace App\Models;

use App\Untils\UploadBase64;
use Backpack\CRUD\app\Models\Traits\CrudTrait;
use App\Models\Scopes\PartnerScope;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Http\UploadedFile;

class Partner extends Model
{
    use CrudTrait;
    use HasFactory;
    use SoftDeletes;

    protected $table = "tbl_media";
    protected $guarded = ["id"];

    public static function boot(): void
    {
        parent::boot(); // TODO: Change the autogenerated stub
        static::addGlobalScope(new PartnerScope);
    }

    public function setAvatarAttribute(UploadedFile|string $value): void
    {
        $attribute_name = "avatar";
        $disk = "uploads";
        $destination_path = "customers/images";
        if ($value instanceof UploadedFile) {
            $this->uploadFileToDisk($value, $attribute_name, $disk, $destination_path, $fileName = $value->getClientOriginalName());
            $this->attributes["avatar"] = $value->getClientOriginalName();
        } else {
            if (str_contains($value, "base")) {
                $this->attributes["avatar"] = UploadBase64::run($value, "/media/", $this->title ?? null);
            }
        }
    }

    public function getAvatarImage(): string
    {
        return '<img style="width:3em" src="' . url("assets/uploads/media/") . "/" . $this->avatar . '">';
    }

    public function PartnerType(): BelongsTo
    {
        return $this->belongsTo(PartnerType::class, "partner_type", "id");
    }
}
